#include "constraint.hh"

bool constraint_t::allow_step(double stat)
  {
    if(is_max_constraint)
    {
      return stat < current_value;
    }
    else
    {
      return stat > current_value;
    }
  }

void constraint_t::check_edge_and_react(double stat)
  {
    if(!has_edge_case)
    {
      return;
    }
    if(is_max_constraint)
    {
      if(stat > edge_sensitivity)
      {
        current_value= after_edge_value;
      }
    }
    else
    {
      if(stat < edge_sensitivity)
      {
        current_value= after_edge_value;
      }
    }
  }

void constraint_t::recover_from_edge()
  {
    if(!has_edge_case)
    {
      return;
    }
    current_value+= change_rate;
    if(is_max_constraint)
    {
      if(current_value > goal_value)
      {
        current_value= goal_value;
      }
    }
    else
    {
      if(current_value < goal_value)
      {
        current_value= goal_value;
      }
    }
  }

int weight_changer_t::weight_step(double stat, size_t step_count)
  {
    double rwc= weight_change_amount +
      weight_change_variation.eval(step_count);
    if(is_gt_compare)
    {
      if(stat > compare_value)
      {
        return static_cast<int>(rwc);
      }
    }
    else
    {
      if(stat < compare_value)
      {
        return static_cast<int>(rwc);
      }
    }
    return 0;
  }
