#include <iostream>

using std::cout;
using std::endl;

enum foot_locations
{
  a_left,
  a_down,
  a_up,
  a_right,
  b_left,
  b_down,
  b_up,
  b_right,
  num_foot_locations
};

char const* foot_strings[num_foot_locations]=
{
  "aL", "aD", "aU", "aR", "bL", "bD", "bU", "bR"
};

double const panel_positions[num_foot_locations][2]=
{
  // 0, 0 is at the center back of the pads.  +y points toward the machine.
  {-2.5, 1.5}, {-1.5, 0.5}, {-1.5, 2.5}, {-0.5, 1.5},
  {0.5, 1.5}, {1.5, 0.5}, {1.5, 2.5}, {2.5, 1.5}
};

int main()
  {
    cout << "double body_positions[num_foot_locations][num_foot_locations][2]=" << endl
      << "{" << endl
      << "  //         aL,    aD,    aU,    aR,    bL,    bD,    bU,    bR" << endl;
    for(int l= a_left; l < num_foot_locations; ++l)
    {
      cout << "  /* " << foot_strings[l] << " */ {";
      for(int r= a_left; r < num_foot_locations; ++r)
      {
        double x_pos= (panel_positions[l][0] + panel_positions[r][0]) / 2.0;
        double y_pos= (panel_positions[l][1] + panel_positions[r][1]) / 2.0;
        cout << "{" << x_pos << ", " << y_pos << "}";
        if(r < b_right)
        {
          cout << ",";
        }
        if(r != a_right && r != b_right)
        {
          cout << " ";
        }
        if(r == a_right)
        {
          cout << endl;
        }
      }
      cout << "}," << endl;
    }
    cout << "};" << endl;
    return 0;
  }
